Interaction in JavaScript Diagram control

Selector

The selector visually represents selected elements, acting as a container to modify their size, position, and rotation angle interactively or programmatically. It supports selecting both single and multiple elements simultaneously.

Selection

An element can be selected by clicking that element. During single click, all previously selected items are cleared.

When selecting/unselecting the diagram elements, the selectionChange event and click gets triggered.
These events enable you to customize the selected elements as needed.

Selecting a group

When a child element of any group is clicked, its contained group is selected instead of the child element. With consecutive clicks on the selected element, selection is changed from top to bottom in the hierarchy of parent group to its children.

Multiple selection

Multiple elements can be selected with the following ways:

Ctrl+Click

During a single click, any existing item in the selection list will be cleared, leaving only the most recently clicked item in the selection list. To avoid clearing the previously selected items, hold down the Ctrl key while clicking.

Rubber band selection

Clicking and dragging in the diagram area allows you to create a rectangular region. The elements covered within this rectangular region will be selected when you release the mouse button.

In rubber band selection, you can set the selection of items by region using the following modes:

  • CompleteIntersect: Selects items that are fully covered within the rectangular selection region.
  • PartialIntersect: Selects items that are partially covered within the rectangular selection region.

This can be configured with the rubberBandSelectionMode.

Select/Unselect elements using API

The select and clearSelection methods are used to dynamically select or clear the selection of elements at runtime. The following code example demonstrates how these methods can be utilized to select or clear the selection of elements.

var diagram = ej.diagrams.Diagram({
    width: '100%', height: 900,
    nodes:[{
    id: 'node1',
    width: 90,
    height: 60,
    offsetX: 100,
    offsetY: 100,
    style: {
        fill:   '#6BA5D7',
        strokeColor: 'white',
        strokeWidth: 1
    },
    }]
});
diagram.appendTo('#diagram');
//Select a specified collection of nodes and connectors in the diagram
diagram.select([diagram.nodes[0]]);
//Removes all elements from the selection list, clearing the current selection.
diagram.clearSelection();

Get selected items

You can get the currently selected nodes and connectors using selectedItems property of the diagram.

var selectedNodes = diagram.selectedItems.nodes;
var selectedConnectors = diagram.selectedItems.connectors;

You can also get the currently selected objects, both nodes and connectors, in a single array called selectedObjects within the selectedItems property of the diagram.

var selectedObjects = diagram.selectedItems.selectedObjects;

Toggle selection

The canToggleSelection property determines whether the selection state of a diagram element should toggle with a mouse click at runtime. By default, this property is set to false. In the following example, the node can be selected with the first click and unselected with the second click.

var node = {
    id: 'node1',
    // Position of the node
    offsetX: 250,
    offsetY: 250,
    // Size of the node
    width: 100,
    height: 100,
    style: { fill: '#6BA5D7', strokeColor: 'white' },
  };
  
  // initialize Diagram component
  
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      nodes: [node],
      //Toggle selection
      selectedItems: { canToggleSelection: true },
    },
    '#element'
  );
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Select entire elements in diagram programmatically

The selectAll method of diagram is used to select all the elements such as nodes/connectors in the diagram. Refer to the following code snippet.

//Selects all the nodes and connectors in diagram
diagram.selectAll();

You can also use the CTRL+A keys to select all nodes and connectors in the diagram.

Drag

You can drag an object by clicking and dragging it. When multiple elements are selected, dragging any one of them moves all selected elements together.
As you drag elements within the diagram, the positionChange event is triggered, providing opportunities to customize the dragged elements.

Resize

The selector in the diagram is designed with eight resizing handles, commonly referred to as thumbs. These handles allow users to adjust the size of selected items by clicking and dragging them. When resizing, dragging any handle modifies the dimensions of the selected elements accordingly. Notably, when dragging one corner handle, the opposite corner remains fixed to specific alignment of the selected item.

During the resizing process, the diagram triggers the sizeChange event, allowing customization based on the size of the element.

NOTE

While dragging and resizing, the objects are snapped towards the nearest objects to make better alignments.

Aspect ratio

Maintaining aspect ratio in diagram means that when you resize a node, by dragging its corner, both its width and height adjust proportionally. This ensures that the node retains its original shape and proportions. Aspect ratio constraints can be applied by configuring the NodeConstraints property.

var node = {
  id: 'node1',
  // Position of the node
  offsetX: 250,
  offsetY: 250,
  // Size of the node
  width: 100,
  height: 100,
  style: { fill: '#6BA5D7', strokeColor: 'white' },
  //Enables aspect ratio
  constraints:
    ej.diagrams.NodeConstraints.Default |
    ej.diagrams.NodeConstraints.AspectRatio,
};

// initialize Diagram component

var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    nodes: [node],
  },
  '#element'
);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Customizing resize-thumb size

You can change the size of the node resize thumb and the connector end point handle by using the handleSize property. The following example shows the resize handle size customization.

var node = {
    // Position of the node
    offsetX: 250,
    offsetY: 250,
    // Size of the node
    width: 100,
    height: 100,
    style: { fill: '#6BA5D7', strokeColor: 'white' },
  };
  var connector = {
    id: 'con1',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 300, y: 150 },
  };
  // initialize Diagram component
  
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      nodes: [node],
      connectors: [connector],
      //Resize Handles and connector end point handle size
      selectedItems: { handleSize: 40 },
    },
    '#element'
  );
  diagram.select([diagram.nodes[0]]);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

The appearance such as fill, stroke, and stroke width of the node resize thumb and connector end point handle can be customized by overriding the e-diagram-resize-handle and e-diagram-endpoint-handle classes respectively.

Rotate

A rotation handler is positioned above the selector. Clicking and dragging this handler in a circular motion rotates the node. The node rotates around a fixed pivot point. A pivot thumb, located at the center of the node, appears during rotation to indicate the fixed point.
Rotating a node triggers the rotateChange event.

Customize rotate handle position

The position of the rotate handle can be adjusted by modifying the pivot point of the node using the pivot property. By default, the pivot point is set to (0.5, 0.5). The following example shows how to render the rotate handle at the left top corner of the node.

var node = {
  // Position of the node
  offsetX: 250,
  offsetY: 250,
  // Size of the node
  width: 100,
  height: 100,
  style: { fill: '#6BA5D7', strokeColor: 'white' },
  //Pivot point
  pivot: { x: 0, y: 0 },
};

// initialize Diagram component

var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    nodes: [node],
  },
  '#element'
);
diagram.select([diagram.nodes[0]]);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Node interaction

Connector editing

Each segment of a selected connector is editable with some specific handles/thumbs.

NOTE

For connector editing, you have to inject the ConnectorEditing module.

Drag connector end points

Source and target points of selected connectors are represented by two handles. Clicking and dragging these handles allows you to adjust the source and target points.

Dragging the connector end points triggers the following events for customization:

When the connector’s source point is changed, the sourcePointChange event is triggered.
When the connector’s target point is changed, the targetPointChange event is triggered.
Connecting a connector to port/node or disconnecting from them triggers the connectionChange event.

Straight segment editing

The end point of each straight segment is represented by a thumb that allows you to edit the segment. You can insert any number of new segments into a straight line by clicking while holding the Shift and Ctrl keys (Ctrl+Shift+Click).

Straight segments can be removed by clicking the segment end point while holding the Ctrl and Shift keys (Ctrl+Shift+Click).

Orthogonal segment editing

Orthogonal thumbs allow you to adjust the length of adjacent segments by clicking and dragging them. When necessary, segments are automatically added or removed during dragging to maintain proper orthogonal routing.

When editing a segment, the segmentChange event is triggered. When new segments are added to the collection of connector segments, the segmentCollectionChange event is triggered.

Bezier segment editing

Bezier segment thumbs allow you to adjust the segments by clicking and dragging them.

Bezier Control Points

Bezier segments are annotated with two thumbs representing the control points. These control points can be adjusted by clicking and dragging the control thumbs. Dragging the control point changes the angle and distance of the points from the segment point, modifying the curve.

The following image shows the interactions with connector

Connector interaction

Restrict Interaction in Negative Axis Area

The Diagram component includes a built-in option to restrict user interactions within the negative axis region—areas defined by negative X or Y coordinates. By enabling the RestrictNegativeAxisDragDrop constraint, the following interactions are prevented:

  • Dragging: Diagram elements cannot be dragged into areas with negative coordinates.
  • Resizing: The size of diagram objects cannot be adjusted to extend into the negative axis.
  • Dropping Symbols: Symbols from the palette cannot be dropped in the negative region.
/**
 * Prevent diagram interactions in the negative region
 */
var diagram = new ej.diagrams.Diagram(
  {
    constraints: ej.diagrams.DiagramConstraints.Default |
                 ej.diagrams.DiagramConstraints.RestrictNegativeAxisDragDrop,
});
diagram.appendTo('#diagram');

negativeAxisRestrict

NOTE

A symbol dragged from the palette will only be added to the diagram if it’s fully positioned within the positive coordinate space.

User handles

User handles are used to add frequently used commands around the selector. To create user handles, define and add them to the userHandles collection of the selectedItems property. The name property of userHandles is used to define the name of the user handle, which can then be used at runtime for identification and customization.

The following events are triggered when interacting with a user handle:

For more information, refer to the user handle events.

Fixed user handle

Fixed user handles are used to perform specific actions when interacted with. Unlike regular user handles, fixedUserHandles are defined within the node/connector object, allowing different fixed user handles to be added to different nodes.

The following events are triggered when interacting with a fixed user handle:

For more information, refer to the fixed user handle events.

Determining Mouse Button Clicks

The diagram component can determine which mouse button was clicked. For example, when the right mouse button is clicked, the click event will specify that the right button was clicked. This is handled through the mouse click event, which provides details about whether the left or right button was clicked.

Notification Description
Left When the left mouse button is clicked, left is notified
Middle When the mouse wheel is clicked, middle is notified
Right When the right mouse button is clicked, right is notified
var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 900
},'#diagram');
diagram.click = function (args) {
// Obtains the mouse button clicked
   let clickedButtons = args.button
};

Allow drop

The diagram supports dropping a node or connector onto another node or connector. To determine the target where the node or connector is dropped, you need to enable the allowDrop constraint in the node’s or connector’s constraints property. This setting enables a highlighter to indicate potential drop targets when dragging any node or connector over another one. Upon dropping the node or connector, the drop event is triggered to indicate which element was dropped over which other element.

Zoom pan

When loading a large diagram, only a certain portion of the diagram is initially visible, the remaining parts are clipped. You can explore these clipped portions by scrolling the scrollbars or panning the diagram. You can zoom in or out on the diagram by using Ctrl + mouse wheel. When the diagram is zoomed or panned, the scrollChange event is triggered.

Pan Status Description
Start When the mouse is clicked and dragged the status is notified as start.
Progress When the mouse is in motion the status is notified as progress.
Completed When panning is stopped the status is notified with completed.

Zoom Pan

Keyboard

Diagram provides support to interact with the elements with key gestures. By default, some in-built commands are bound with a relevant set of key combinations.

The following table illustrates those commands with the associated key values.

Shortcut Key Command Description
Ctrl + A selectAll Select all nodes/connectors in the diagram.
Ctrl + C copy Copy the diagram selected elements.
Ctrl + V paste Pastes the copied elements.
Ctrl + X cut Cuts the selected elements.
Ctrl + Z undo Reverses the last editing action performed on the diagram.
Ctrl + Y redo Restores the last editing action when no other actions have occurred since the last undo on the diagram.
Delete delete Deletes the selected elements.
Ctrl/Shift + Click on object Multiple selection Selector binds all selected nodes/connectors.
Up Arrow nudge(“up”) nudgeUp: Moves the selected elements towards up by one pixel.
Down Arrow nudge(“down”) nudgeDown: Moves the selected elements towards down by one pixel.
Left Arrow nudge(“left”) nudgeLeft: Moves the selected elements towards left by one pixel.
Right Arrow nudge(“right”) nudgeRight: Moves the selected elements towards right by one pixel.
Ctrl + MouseWheel zoom Zoom (Zoom in/Zoom out the diagram).
F2 startLabelEditing Starts to edit the label of selected element.
Esc endLabelEditing Sets the label mode as view and stops editing.
Tab Tab to Focus Select the diagram element based on the rendering order when using the “Tab” key.
Shift + Tab Go to Previous Object This command is employed to shift the selection to the preceding object based on the z-order.
Control + B Bold Toggle bold formatting for the selected text.
Control + I Italic Toggle italic formatting for the selected text.
Control + U Underline Toggle underline formatting for the selected text.
Control + D Duplicate Duplicate a selected shape.
Control + G Group Group together multiple selected shapes, allowing them to be treated as a single shape.
Control + Shift + U UnGroup Ungroup shapes within a previously grouped selection.
Control + R Rotate clockwise Rotate the selected nodes in clockwise.
Control + L Rotate anti-clockwise Rotate the selected nodes in counterclockwise.
Control + H Flip Horizontal Flip the selected elements horizontally.
Control + J Flip Vertical Flip the selected elements vertically.
Control + 1 Pointer tool Activate the pointer tool.
Control + 2 Text tool Activate the text tool.
Control + 3 Connector tool Activate the connector tool.
Control + 5 Freeform tool Activate the freeform tool.
Control + 6 Line tool Activate the polyline tool.
Control + + Zoom In Zoom in the diagram.
Control + - Zoom Out Zoom out the diagram.
Shift + Up Arrow Up Moves the selected elements towards up by 5 pixel.
Shift + Down Arrow Down Moves the selected elements towards down by 5 pixel.
Shift + Left Arrow Left Moves the selected elements towards left by 5 pixel.
Shift + Right Arrow Right Moves the selected elements towards right by 5 pixel.
Control + Shift + L Align Text Left Align the selected text to the left.
Control + Shift + C Center Text Horizontally Center the selected text horizontally.
Control + Shift + R Align Text Right Align the selected text to the right.
Control + Shift + J Justify Text Horizontally Justify the selected text, aligning it to both the left and right margins.
Control + Shift + E Top-align Text Vertically Align the selected text to the top vertically.
Control + Shift + M Center Text Vertically Center the selected text vertically.
Control + Shift + V Bottom-align Text Vertically Align the selected text to the bottom vertically.
Control + Shift + B Send To Back Send the selected shape backward in the stacking order, making it appear behind other shapes.
Control + Shift + F Bring To Front Bring the selected shape forward in the stacking order, making it appear in front of other shapes.
Control + [ Send Backward Move the selected shape one step backward in the layer order.
Control + ] Bring Forward Move the selected shape one step forward in the layer order.

NOTE

Please note that the positionChange event is triggered for dragging nodes/connectors using mouse interactions only and not supported for Keyboard interactions

See Also

Interaction in Angular Diagram Component

Selector

The selector provides a visual representation of selected elements in the Angular Diagram, serving as an interactive boundary that enables users to modify the size, position, and rotation angle of selected items through direct manipulation or programmatic control. The selector supports both single and multiple element selection simultaneously.

Selection

Elements can be selected by clicking on them directly. During a single click operation, all previously selected items are automatically cleared from the selection.

When selecting or unselecting diagram elements, the selectionChange event and click event are triggered. These events provide opportunities to customize the behavior and appearance of selected elements based on application requirements.

Selecting a group

When clicking on a child element within any group, the diagram selects the containing group instead of the individual child element. Subsequent clicks on the already-selected element will cycle the selection through the hierarchy, moving from the top-level parent group down to its nested children.

Multiple selection

Multiple elements can be selected using the following methods:

Ctrl+Click

By default, clicking on an element clears any existing selection and selects only the clicked item. To maintain existing selections while adding new items, hold the Ctrl key while clicking additional elements.

Rubber band selection

Click and drag in an empty area of the diagram to create a rectangular selection region. All elements within this region will be selected when the mouse button is released.

Rubber band selection supports two modes for determining which items to select:

  • CompleteIntersect: Selects only items that are completely contained within the rectangular selection region
  • PartialIntersect: Selects items that are partially or completely covered by the rectangular selection region

Configure this behavior using the rubberBandSelectionMode property.

Select/Unselect elements using API

The select and clearSelection methods enable dynamic selection and deselection of elements at runtime. The following example demonstrates how to use these methods:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { DiagramComponent, NodeModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
  selector: "app-container",
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="900px" [nodes]='nodes'></ejs-diagram>`
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram: DiagramComponent;
    
    public nodes: NodeModel[] = [
        {
            id: 'node1',
            width: 90,
            height: 60,
            offsetX: 100,
            offsetY: 100,
            style: {
                fill: '#6BA5D7',
                strokeColor: 'white',
                strokeWidth: 1
            },
        }
    ]
    
    ngOnInit(): void {
        //Select a specified collection of nodes and connectors in the diagram
        this.diagram.select([this.diagram.nodes[0]]);
        //Removes all elements from the selection list, clearing the current selection
        this.diagram.clearSelection();
    }
}

Get selected items

Access the currently selected nodes and connectors through the selectedItems property:

this.selectedNodes = this.diagram.selectedItems.nodes;
this.selectedConnectors = this.diagram.selectedItems.connectors;

Alternatively, retrieve all currently selected objects (both nodes and connectors) in a single array using selectedObjects:

this.selectedObjects = this.diagram.selectedItems.selectedObjects;

Toggle selection

The canToggleSelection property determines whether clicking on a selected element should deselect it. By default, this property is set to false. When enabled, the first click selects the element, and the second click deselects it.

import {
  DiagramModule, DiagramComponent,
  NodeModel,
  ShapeStyleModel,
} from '@syncfusion/ej2-angular-diagrams';

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';

@Component({
  imports: [DiagramModule],

  providers: [],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults] ='getNodeDefaults' [nodes]='nodes' [selectedItems]='selectedItems'>
    </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram')
  public diagram?: DiagramComponent;
  public nodes: NodeModel[] = [
    {
      id: 'node1',
      // Position of the node
      offsetX: 250,
      offsetY: 250,
      // Size of the node
      width: 100,
      height: 100,
      style: { fill: '#6BA5D7', strokeColor: 'white' },
    },
  ];
  public selectedItems: any = { canToggleSelection: true };
  public getNodeDefaults(node: NodeModel): NodeModel {
    node.height = 100;
    node.width = 100;
    return node;
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Select entire elements in diagram programmatically

Use the selectAll method to programmatically select all nodes and connectors in the diagram:

//Selects all the nodes and connectors in diagram
this.diagram.selectAll();

Alternatively, use the keyboard shortcut Ctrl+A to select all elements in the diagram.

Drag

Drag elements by clicking and dragging them to new positions. When multiple elements are selected, dragging any one of them moves the entire selection together. During drag operations, the positionChange event is triggered, providing opportunities to customize or validate the drag behavior.

Resize

The selector displays eight resizing handles (thumbs) around selected elements. These handles allow users to modify element dimensions by clicking and dragging. When resizing using corner handles, the opposite corner remains fixed to maintain proper alignment during the resize operation.

The sizeChange event is triggered during resize operations, enabling customization based on the element’s changing dimensions.

While dragging and resizing, elements automatically snap to nearby objects for better alignment.

Aspect ratio

Aspect ratio constraints ensure that when resizing a node by dragging its corner handles, both width and height adjust proportionally to maintain the original shape. Configure aspect ratio constraints using the NodeConstraints property.

import {
  DiagramModule, NodeConstraints, DiagramComponent,
  NodeModel,
  ShapeStyleModel,
} from '@syncfusion/ej2-angular-diagrams';

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';

@Component({
  imports: [DiagramModule],

  providers: [],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults] ='getNodeDefaults' [nodes]='nodes'>
    </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram')
  public diagram?: DiagramComponent;
  public nodes: NodeModel[] = [
    {
      id: 'node1',
      // Position of the node
      offsetX: 250,
      offsetY: 250,
      // Size of the node
      width: 100,
      height: 100,
      style: { fill: '#6BA5D7', strokeColor: 'white' },
      //Enables aspect ratio
      constraints:
        NodeConstraints.Default |
        NodeConstraints.AspectRatio,
    },
  ];
  public getNodeDefaults(node: NodeModel): NodeModel {
    node.height = 100;
    node.width = 100;
    return node;
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customizing resize handle size

Customize the size of resize handles and connector endpoint handles using the handleSize property:

import {
  DiagramModule, DiagramComponent,
  NodeModel,
  ShapeStyleModel,
} from '@syncfusion/ej2-angular-diagrams';

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';

@Component({
  imports: [DiagramModule],

  providers: [],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults] ='getNodeDefaults' [nodes]='nodes' [selectedItems]='selectedItems' (created)='create()'>
    </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram')
  public diagram?: DiagramComponent;
  public create() {
    (this.diagram as DiagramComponent).select([(this.diagram as DiagramComponent).nodes[0]]);
  }
  public nodes: NodeModel[] = [
    {
      id: 'node1',
      // Position of the node
      offsetX: 250,
      offsetY: 250,
      // Size of the node
      width: 100,
      height: 100,
      style: { fill: '#6BA5D7', strokeColor: 'white' },
    },
  ];
  public selectedItems: any = { handleSize: 40 };
  public getNodeDefaults(node: NodeModel): NodeModel {
    node.height = 100;
    node.width = 100;
    return node;
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customize the appearance of resize handles and connector endpoints by overriding the e-diagram-resize-handle and e-diagram-endpoint-handle CSS classes to modify fill, stroke, and stroke width properties.

Rotate

A rotation handler appears above the selector when elements are selected. Click and drag this handler in a circular motion to rotate selected elements. Elements rotate around a fixed pivot point, indicated by a pivot thumb that appears at the center during rotation operations.

Rotation operations trigger the rotateChange event for customization purposes.

Customize rotate handle position

Adjust the rotation handle position by modifying the node’s pivot property. The default pivot point is (0.5, 0.5), representing the center of the node. The following example positions the rotate handle at the top-left corner:

import {
  DiagramModule, DiagramComponent,
  NodeModel,
  ShapeStyleModel,
} from '@syncfusion/ej2-angular-diagrams';

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';

@Component({
  imports: [DiagramModule],

  providers: [],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults] ='getNodeDefaults' [nodes]='nodes' (created)='create()'>
    </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram')
  public diagram?: DiagramComponent;
  public create() {
    (this.diagram as DiagramComponent).select([(this.diagram as DiagramComponent).nodes[0]]);
  }
  public nodes: NodeModel[] = [
    {
      id: 'node1',
      // Position of the node
      offsetX: 250,
      offsetY: 250,
      // Size of the node
      width: 100,
      height: 100,
      style: { fill: '#6BA5D7', strokeColor: 'white' },
      //Pivot point
      pivot: { x: 0, y: 0 },
    },
  ];
  public getNodeDefaults(node: NodeModel): NodeModel {
    node.height = 100;
    node.width = 100;
    return node;
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Node interaction

Connection editing

Selected connectors display editable handles on each segment, enabling direct manipulation of connector paths and endpoints.

To enable connector editing functionality, inject the ConnectorEditing module into your application.

Drag connector endpoints

Source and target endpoints of selected connectors are represented by dedicated handles. Click and drag these handles to reposition the connector’s start and end points.

Endpoint dragging operations trigger the following events:

Straight segment editing

Each endpoint of straight connector segments displays an editable handle. Add new segments to a straight connector by Ctrl+Shift+Click at the desired position along the connector path.

Remove straight segments by Ctrl+Shift+Click on the segment endpoint handle.

Orthogonal segment editing

Orthogonal connectors display handles that allow adjustment of adjacent segment lengths through click and drag operations. The diagram automatically adds or removes segments as needed during editing to maintain proper orthogonal routing.

Segment editing operations trigger these events:

Bezier segment editing

Bezier connectors provide handles for direct segment manipulation through click and drag operations.

Bezier Control Points

Bezier segments display two control point handles that define the curve characteristics. Drag these control points to adjust the angle and distance from the segment endpoints, modifying the curve shape and direction.

Connector interaction

Restrict interaction in negative axis area

The diagram component provides built-in constraints to prevent user interactions within negative coordinate regions (areas with negative X or Y values). Enable the RestrictNegativeAxisDragDrop constraint to prevent:

  • Dragging elements into negative coordinate areas
  • Resizing elements to extend into negative regions
  • Dropping symbols from the palette into negative areas
@Component({
  selector: "app-container",
  template: `<ejs-diagram id="diagram" width="100%" height="580px" [constraints]='constraints'>
             </ejs-diagram>`
})
export class AppComponent {
// Prevent diagram interactions in the negative region
public constraints: DiagramConstraints = DiagramConstraints.Default |
                                         DiagramConstraints.RestrictNegativeAxisDragDrop
}

negativeAxisRestrict

Symbols dragged from the palette will only be added to the diagram when positioned entirely within positive coordinate space.

User handles

User handles provide quick access to frequently used commands around selected elements. Define user handles by adding them to the userHandles collection within the selectedItems property. Use the name property for runtime identification and customization.

User handle interactions trigger the following events:

Fixed user handles

Fixed user handles perform specific actions and are defined directly within node or connector objects, allowing different handles for different elements. Unlike regular user handles, fixedUserHandles remain visible even when elements are not selected.

Fixed user handle interactions trigger these events:

Determining mouse button clicks

The diagram component can identify which mouse button triggered click events. The click event provides details about the specific button used:

Button Description
Left Triggered when the left mouse button is clicked
Middle Triggered when the mouse wheel button is clicked
Right Triggered when the right mouse button is clicked
@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px" (click)="click($event)"></ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    ngOnInit(): void {
    }
    public click(args: IClickEventArgs): void {
        // Identify which mouse button was clicked
        var button = args.button;
    }
}

Allow drop

The diagram supports drag-and-drop operations between elements. Enable the allowDrop constraint on target nodes or connectors to indicate valid drop zones. When this constraint is enabled, a visual highlighter appears when dragging elements over valid drop targets. The drop event is triggered when elements are successfully dropped, providing information about both the dropped element and the drop target.

Zoom and pan

Navigate large diagrams using zoom and pan operations. Scroll bars enable navigation to clipped portions of the diagram, while click-and-drag operations pan the viewport. Use Ctrl + mouse wheel to zoom in or out. The scrollChange event is triggered during zoom and pan operations.

Pan Status Description
Start Triggered when mouse click-and-drag begins
Progress Triggered during mouse movement while dragging
Completed Triggered when pan operation ends

Zoom Pan

Keyboard shortcuts

The diagram provides comprehensive keyboard support for common operations. The following table lists available keyboard shortcuts:

Selection and Navigation

Shortcut Command Description
Ctrl + A selectAll Select all nodes and connectors
Tab Tab to Focus Select elements based on rendering order
Shift + Tab Go to Previous Object Select previous element in z-order

Editing Operations

Shortcut Command Description
Ctrl + C copy Copy selected elements
Ctrl + V paste Paste copied elements
Ctrl + X cut Cut selected elements
Ctrl + Z undo Reverse last editing action
Ctrl + Y redo Restore last undone action
Delete delete Delete selected elements
Ctrl + D Duplicate Duplicate selected elements

Movement and Positioning

Shortcut Command Description
Arrow Keys nudge Move selected elements by 1 pixel
Shift + Arrow Keys nudge Move selected elements by 5 pixels
Ctrl + R Rotate clockwise Rotate selected elements clockwise
Ctrl + L Rotate anti-clockwise Rotate selected elements counter-clockwise
Ctrl + H Flip Horizontal Flip selected elements horizontally
Ctrl + J Flip Vertical Flip selected elements vertically

Grouping and Ordering

Shortcut Command Description
Ctrl + G Group Group selected elements
Ctrl + Shift + U UnGroup Ungroup selected elements
Ctrl + Shift + B Send To Back Send elements to back of stacking order
Ctrl + Shift + F Bring To Front Bring elements to front of stacking order
Ctrl + [ Send Backward Move elements one step backward
Ctrl + ] Bring Forward Move elements one step forward

Tools and Views

Shortcut Command Description
Ctrl + 1 Pointer tool Activate pointer tool
Ctrl + 2 Text tool Activate text tool
Ctrl + 3 Connector tool Activate connector tool
Ctrl + 5 Freeform tool Activate freeform tool
Ctrl + 6 Line tool Activate polyline tool
Ctrl + + Zoom In Zoom in the diagram
Ctrl + - Zoom Out Zoom out the diagram

Text Formatting

Shortcut Command Description
F2 startLabelEditing Begin editing element labels
Esc endLabelEditing Stop label editing
Ctrl + B Bold Toggle bold text formatting
Ctrl + I Italic Toggle italic text formatting
Ctrl + U Underline Toggle underline formatting
Ctrl + Shift + L Align Text Left Left-align selected text
Ctrl + Shift + C Center Text Horizontally Center text horizontally
Ctrl + Shift + R Align Text Right Right-align selected text
Ctrl + Shift + J Justify Text Horizontally Justify text alignment
Ctrl + Shift + E Top-align Text Vertically Align text to top
Ctrl + Shift + M Center Text Vertically Center text vertically
Ctrl + Shift + V Bottom-align Text Vertically Align text to bottom

The positionChange event is triggered only for mouse-based dragging operations and does not support keyboard-based movement interactions.

See Also

Interaction in React Diagram component

Selection

Selector provides a visual representation of selected elements. It behaves like a container and allows to update the size, position, and rotation angle of the selected elements through interaction and by using program. Single or multiple elements can be selected at a time.

Single selection

An element can be selected by clicking that element. During single click, all previously selected items are cleared. The following image shows how the selected elements are visually represented.

Single Selection

While selecting the diagram elements, the selectionChange event and click gets triggered.
These events enable you to customize the selected elements as needed.

Selecting a group

When a child element of any group is clicked, its contained group is selected instead of the child element. With consecutive clicks on the selected element, selection is changed from top to bottom in the hierarchy of parent group to its children.

Multiple selection

Multiple elements can be selected with the following ways:

Ctrl+Click

During single click, any existing item in the selection list be cleared, and only the item clicked recently is there in the selection list. To avoid cleaning the old selected item, Ctrl key must be on hold when clicking.

Rubber band selection

Clicking and dragging in the diagram area allows you to create a rectangular region. The elements covered within this rectangular region will be selected when you release the mouse button.

In rubber band selection, you can set the selection of items by region using the following modes:

  • CompleteIntersect: Selects items that are fully covered within the rectangular selection region.
  • PartialIntersect: Selects items that are partially covered within the rectangular selection region.

This can be configured with the rubberBandSelectionMode.

Multiple Rubberband Selection

Select/Unselect elements using API

The select and clearSelection methods are used to dynamically select or clear the selection of elements at runtime. The following code example demonstrates how these methods can be utilized to select or clear the selection of elements.

let diagramInstance: DiagramComponent;
let nodes = [
  {
    id: 'node1',
    width: 90,
    height: 60,
    offsetX: 100,
    offsetY: 100,
    style: {
        fill:   '#6BA5D7',
        strokeColor: 'white',
        strokeWidth: 1
    },
    }
]
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      ref={(diagram) => (diagramInstance = diagram)}
      width={'100%'}
      height={'600px'}
      nodes={nodes}
      created={() => {
            //Select a specified collection of nodes and connectors in the diagram
            diagramInstance.select([diagramInstance.nodes[0]]);
            //Removes all elements from the selection list, clearing the current selection.
            diagramInstance.clearSelection();
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Get selected items

You can get the current selected items from the nodes and connectors collection of the selectedItems property of the diagram model.

let diagramInstance: DiagramComponent;
let selectedNodes: NodeModel[] = diagramInstance.selectedItems.nodes;
let selectedConnector: ConnectorModel[] = diagramInstance.selectedItems.connectors;
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      ref={(diagram) => (diagramInstance = diagram)}
      width={'100%'}
      height={'600px'}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Toggle selection

The canToggleSelection property determines whether the selection state of a diagram element should toggle with a mouse click at runtime. By default, this property is set to false. In the following example, the node can be selected with the first click and unselected with the second click.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DiagramComponent } from '@syncfusion/ej2-react-diagrams';
let diagramInstance;
let node = [
  {
    id: 'node1',
    // Position of the node
    offsetX: 250,
    offsetY: 250,
    // Size of the node
    width: 100,
    height: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
  },
];
function App() {
  return (
    <DiagramComponent
      id="container"
      ref={(diagram) => (diagramInstance = diagram)}
      width={700}
      height={700}
      nodes={node}
      //Toggle selection
      selectedItems=
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { NodeModel, DiagramComponent } from '@syncfusion/ej2-react-diagrams';
let diagramInstance: DiagramComponent;
let node: NodeModel[] = [
  {
    id: 'node1',
    // Position of the node
    offsetX: 250,
    offsetY: 250,
    // Size of the node
    width: 100,
    height: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
  },
];
function App() {
  return (
    <DiagramComponent
      id="container"
      ref={(diagram) => (diagramInstance = diagram)}
      width={700}
      height={700}
      nodes={node}
      //Toggle selection
      selectedItems=
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Select entire elements in diagram programmatically

The client-side method selectAll used to select all the elements such as nodes/connectors in the diagram. Refer to the following link which shows how to use selectAll method on the diagram.

let diagramInstance: DiagramComponent;
let nodes: NodeModel[] = [
  {
    id: 'node1',
    width: 90,
    height: 60,
    offsetX: 100,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
      strokeWidth: 1,
    },
  },
  {
    id: 'node2',
    width: 90,
    height: 60,
    offsetX: 300,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
      strokeWidth: 1,
    },
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      ref={(diagram) => (diagramInstance = diagram)}
      width={'100%'}
      height={'600px'}
      nodes={nodes}
      created={() => {
        //Select a specified collection of nodes and connectors in the diagram
        diagramInstance.selectAll();
      }}
    />
  );
}
const root = createRoot(document.getElementById('diagram'));
root.render(<App />);

You can also use the CTRL+A keys to select all nodes and connectors in the diagram.

Drag

  • An object can be dragged by clicking and dragging it. When multiple elements are selected, dragging any one of the selected elements move every selected element.
  • When you drag the elements in the diagram, the positionChange event gets triggered and to do customization in this event.

Drag

Resize

  • Selector is surrounded by eight thumbs. When dragging these thumbs, selected items can be resized.
  • When one corner of the selector is dragged, opposite corner is in a static position.
  • When a node is resized, the sizeChange event gets triggered.

Resize

NOTE

While dragging and resizing, the objects are snapped towards the nearest objects to make better alignments.

Aspect ratio

Maintaining aspect ratio in diagram means that when you resize a node, by dragging its corner, both its width and height adjust proportionally. This ensures that the node retains its original shape and proportions. Aspect ratio constraints can be applied by configuring the NodeConstraints property.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  NodeConstraints,
  DiagramComponent,
} from '@syncfusion/ej2-react-diagrams';
let diagramInstance;
let node = [
  {
    id: 'node1',
    // Position of the node
    offsetX: 250,
    offsetY: 250,
    // Size of the node
    width: 100,
    height: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    //Enables aspect ratio
    constraints: NodeConstraints.Default | NodeConstraints.AspectRatio,
  },
];
function App() {
  return (
    <DiagramComponent
      id="container"
      ref={(diagram) => (diagramInstance = diagram)}
      width={700}
      height={700}
      nodes={node}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  NodeModel,
  NodeConstraints,
  DiagramComponent,
} from '@syncfusion/ej2-react-diagrams';
let diagramInstance: DiagramComponent;
let node: NodeModel[] = [
  {
    id: 'node1',
    // Position of the node
    offsetX: 250,
    offsetY: 250,
    // Size of the node
    width: 100,
    height: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    //Enables aspect ratio
    constraints: NodeConstraints.Default | NodeConstraints.AspectRatio,
  },
];
function App() {
  return (
    <DiagramComponent
      id="container"
      ref={(diagram) => (diagramInstance = diagram)}
      width={700}
      height={700}
      nodes={node}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Customize the resize-thumb size

You can change the size of the node resize thumb and the connector end point handle by using the handleSize property. The appearance such as fill, stroke, and stroke width of the node resize thumb and connector end point handle can be customized by overriding the e-diagram-resize-handle and e-diagram-endpoint-handle classes respectively.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, } from "@syncfusion/ej2-react-diagrams";
let node = [{
        // Position of the node
        offsetX: 250,
        offsetY: 250,
        // Size of the node
        width: 100,
        height: 100,
        style: {
            fill: '#6BA5D7',
            strokeColor: 'white'
        }
    }];
function App() {
    return (<DiagramComponent id="container" width={'100%'} height={'600px'} nodes={node} selectedItems=/>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    Diagram,
    DiagramComponent,
    ConnectorModel,
    NodeModel,
} from "@syncfusion/ej2-react-diagrams";
let node: NodeModel[] = [{
    // Position of the node
    offsetX: 250,
    offsetY: 250,
    // Size of the node
    width: 100,
    height: 100,
    style: {
        fill: '#6BA5D7',
        strokeColor: 'white'
    }
}];
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      nodes={node}
      selectedItems=
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

The appearance such as fill, stroke, and stroke width of the node resize thumb and connector end point handle can be customized by overriding the e-diagram-resize-handle and e-diagram-endpoint-handle classes respectively.

Rotate

  • A rotate handler is placed above the selector. Clicking and dragging the handler in a circular direction lead to rotate the node.
  • The node is rotated with reference to the static pivot point.
  • Pivot thumb (thumb at the middle of the node) appears while rotating the node to represent the static point.

rotate

Customize rotate handle position

The position of the rotate handle can be adjusted by modifying the pivot point of the node using the pivot property. By default, the pivot point is set to (0.5, 0.5). The following example shows how to render the rotate handle at the left top corner of the node.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { Diagram, DiagramComponent, SnapConstraints, Snapping } from "@syncfusion/ej2-react-diagrams";
Diagram.Inject(Snapping);
let snapSettings = {
    constraints: SnapConstraints.SnapToLines | SnapConstraints.ShowLines
};
// A node is created and stored in nodes array.
let node = [{
        // Position of the node
        offsetX: 250,
        offsetY: 250,
        // Size of the node
        width: 100,
        height: 100,
        style: {
            fill: '#6BA5D7',
            strokeColor: 'white'
        },
        // Text(label) added to the node
    }];
// initialize Diagram component
function App() {
    return (<DiagramComponent id="container" width={'100%'} height={'600px'} 
    // Add node
    nodes={node} snapSettings={snapSettings}/>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    Diagram,
    NodeModel,
    DiagramComponent,
    SnapSettingsModel,
    SnapConstraints,
    UndoRedo,
    GridlinesModel,
    Snapping,
    Inject
} from "@syncfusion/ej2-react-diagrams";
Diagram.Inject(Snapping);
let snapSettings: SnapSettingsModel = {
    constraints: SnapConstraints.SnapToLines | SnapConstraints.ShowLines
};
// A node is created and stored in nodes array.
let node: NodeModel[] = [{
    // Position of the node
    offsetX: 250,
    offsetY: 250,
    // Size of the node
    width: 100,
    height: 100,
    style: {
        fill: '#6BA5D7',
        strokeColor: 'white'
    },
    // Text(label) added to the node
}];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={node}
      snapSettings={snapSettings}
      // render initialized Diagram
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Node interaction

Connection editing

Each segment of a selected connector is editable with some specific handles/thumbs.

NOTE

For connector editing, you have to inject the ConnectorEditing module.

Drag connector end points

Source and target points of the selected connectors are represented with two handles. Clicking and dragging those handles help you to adjust the source and target points.

Drag End Point Handles

Dragging the connector end points triggers the following events for customization:

When the connector source point is changed, the sourcePointChange event gets triggered.
When the connector target point is changed, the targetPointChange event gets triggered.
When you connect connector with ports/node or disconnect from it, the connectionChange event gets triggered.

Straight segment editing

The end point of each straight segment is represented by a thumb that allows you to edit the segment. You can insert any number of new segments into a straight line by clicking while holding the Shift and Ctrl keys (Ctrl+Shift+Click).

Straight Segment Editing Addition

Straight segments can be removed by clicking the segment end point while holding the Ctrl and Shift keys (Ctrl+Shift+Click).

Straight Segment Editing Remove

Orthogonal segment editing

  • Orthogonal thumbs allow you to adjust the length of adjacent segments by clicking and dragging it.
  • When necessary, some segments are added or removed automatically, when dragging the segment. This is to maintain proper routing of orthogonality between segments.

orthogonal Segment Edit

Bezier segment editing

Bezier segment thumbs allow you to adjust the segments by clicking and dragging them.

Bezier Control Points

Bezier segments are annotated with two thumbs representing the control points. These control points can be adjusted by clicking and dragging the control thumbs. Dragging the control point changes the angle and distance of the points from the segment point, modifying the curve.

Bezier Segement Thumb

Restrict Interaction in Negative Axis Area

The Diagram component includes a built-in option to restrict user interactions within the negative axis region—areas defined by negative X or Y coordinates. By enabling the RestrictNegativeAxisDragDrop constraint, the following interactions are prevented:

  • Dragging: Diagram elements cannot be dragged into areas with negative coordinates.
  • Resizing: The size of diagram objects cannot be adjusted to extend into the negative axis.
  • Dropping Symbols: Symbols from the palette cannot be dropped in the negative region.
/**
 * Prevent diagram interactions in the negative region
 */
function App() {
  return (
    <DiagramComponent id="container"
      constraints={
        DiagramConstraints.Default | DiagramConstraints.RestrictNegativeAxisDragDrop
      }
    />
  );
}

negativeAxisRestrict

NOTE

A symbol dragged from the palette will only be added to the diagram if it’s fully positioned within the positive coordinate space.

User handles

User handles are used to add some frequently used commands around the selector. To create user handles, define and add them to the userHandles collection of the selectedItems property. The name property of user handle is used to define the name of the user handle and its further used to find the user handle at runtime and do any customization.

The following events are triggered when interacting with a user handle:

click - Triggered when the user handle is clicked.
onUserHandleMouseEnter - Triggered when the mouse enters the user handle region.
onUserHandleMouseDown - Triggered when the mouse is pressed down on the user handle.
onUserHandleMouseUp - Triggered when the mouse is released on the user handle.
onUserHandleMouseLeave - Triggered when the mouse leaves the user handle region.

For more information, refer to the user handle events.

Fixed user handle

Fixed user handles are used to perform specific actions when interacted with. Unlike regular user handles, fixedUserHandles are defined within the node/connector object, allowing different fixed user handles to be added to different nodes.

The following events are triggered when interacting with a fixed user handle:

For more information, refer to the fixed user handle events.

Determining Mouse Button Clicks

The diagram component can determine which mouse button was clicked. For example, when the right mouse button is clicked, the click event will specify that the right button was clicked. This is handled through the mouse click event, which provides details about whether the left or right button was clicked.

Notification Description
Left When the left mouse button is clicked, left is notified
Middle When the mouse wheel is clicked, middle is notified
Right When the right mouse button is clicked, right is notified
let diagramInstance: DiagramComponent;
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      ref={(diagram) => (diagramInstance = diagram)}
      width={'100%'}
      height={'600px'}
      click={(args: : IClickEventArgs) => {
        //Obtains the button clicked
        let button = args.button;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Allow drop

The diagram supports dropping a node or connector onto another node or connector. To determine the target where the node or connector is dropped, you need to enable the allowDrop constraint in the node’s or connector’s constraints property. This setting enables a highlighter to indicate potential drop targets when dragging any node or connector over another one. Upon dropping the node or connector, the drop event is triggered to indicate which element was dropped over which other element.

Zoom pan

When a large diagram is loaded, only certain portion of the diagram is visible. The remaining portions are clipped. Clipped portions can be explored by scrolling the scrollbars or panning the diagram. You can zoom in or out on the diagram by using Ctrl + mouse wheel. When the diagram is zoomed or panned, the scrollChange event gets triggered.

Pan Status Description
Start When the mouse is clicked and dragged the status is notified as start.
Progress When the mouse is in motion the status is notified as progress.
Completed When panning is stopped the status is notified with completed.

Zoom Pan

Keyboard

Diagram provides support to interact with the elements with key gestures. By default, some in-built commands are bound with a relevant set of key combinations.

The following table illustrates those commands with the associated key values.

Shortcut Key Command Description
Ctrl + A selectAll Select all nodes/connectors in the diagram.
Ctrl + C copy Copy the diagram selected elements.
Ctrl + V paste Pastes the copied elements.
Ctrl + X cut Cuts the selected elements.
Ctrl + Z undo Reverses the last editing action performed on the diagram.
Ctrl + Y redo Restores the last editing action when no other actions have occurred since the last undo on the diagram.
Delete delete Deletes the selected elements.
Ctrl/Shift + Click on object   Multiple selection (Selector binds all selected nodes/connectors).
Up Arrow nudge(“up”) nudgeUp: Moves the selected elements towards up by one pixel.
Down Arrow nudge(“down”) nudgeDown: Moves the selected elements towards down by one pixel.
Left Arrow nudge(“left”) nudgeLeft: Moves the selected elements towards left by one pixel.
Right Arrow nudge(“right”) nudgeRight: Moves the selected elements towards right by one pixel.
Ctrl + MouseWheel zoom Zoom (Zoom in/Zoom out the diagram).
F2 startLabelEditing Starts to edit the label of selected element.
Esc endLabelEditing Sets the label mode as view and stops editing.
Tab Tab to Focus Select the diagram element based on the rendering order when using the “Tab” key.
Shift + Tab Go to Previous Object This command is employed to shift the selection to the preceding object based on the z-order.
Control + B Bold Toggle bold formatting for the selected text.
Control + I Italic Toggle italic formatting for the selected text.
Control + U Underline Toggle underline formatting for the selected text.
Control + D Duplicate Duplicate a selected shape.
Control + G Group Group together multiple selected shapes, allowing them to be treated as a single shape.
Control + Shift + U UnGroup Ungroup shapes within a previously grouped selection.
Control + R Rotate clockwise Rotate the selected nodes in clockwise.
Control + L Rotate anti-clockwise Rotate the selected nodes in counterclockwise.
Control + H Flip Horizontal Flip the selected elements horizontally.
Control + J Flip Vertical Flip the selected elements vertically.
Control + 1 Pointer tool Activate the pointer tool.
Control + 2 Text tool Activate the text tool.
Control + 3 Connector tool Activate the connector tool.
Control + 5 Freeform tool Activate the freeform tool.
Control + 6 Line tool Activate the polyline tool.
Control + + Zoom In Zoom in the diagram.
Control + - Zoom Out Zoom out the diagram.
Shift + Up Arrow Up Moves the selected elements towards up by 5 pixel.
Shift + Down Arrow Down Moves the selected elements towards down by 5 pixel.
Shift + Left Arrow Left Moves the selected elements towards left by 5 pixel.
Shift + Right Arrow Right Moves the selected elements towards right by 5 pixel.
Control + Shift + L Align Text Left Align the selected text to the left.
Control + Shift + C Center Text Horizontally Center the selected text horizontally.
Control + Shift + R Align Text Right Align the selected text to the right.
Control + Shift + J Justify Text Horizontally Justify the selected text, aligning it to both the left and right margins.
Control + Shift + E Top-align Text Vertically Align the selected text to the top vertically.
Control + Shift + M Center Text Vertically Center the selected text vertically.
Control + Shift + V Bottom-align Text Vertically Align the selected text to the bottom vertically.
Control + Shift + B Send To Back Send the selected shape backward in the stacking order, making it appear behind other shapes.
Control + Shift + F Bring To Front Bring the selected shape forward in the stacking order, making it appear in front of other shapes.
Control + [ Send Backward Move the selected shape one step backward in the layer order.
Control + ] Bring Forward Move the selected shape one step forward in the layer order.

See Also

Interaction in Vue Diagram component

Selection

Selector provides a visual representation of selected elements. It behaves like a container and allows to update the size, position, and rotation angle of the selected elements through interaction and by using program. Single or multiple elements can be selected at a time.

Single selection

An element can be selected by clicking that element. During single click, all previously selected items are cleared.

When selecting/unselecting the diagram elements, the selectionChange event and click gets triggered.
These events enable you to customize the selected elements as needed.

Selecting a group

When a child element of any group is clicked, its contained group is selected instead of the child element. With consecutive clicks on the selected element, selection is changed from top to bottom in the hierarchy of parent group to its children.

Multiple selection

Multiple elements can be selected with the following ways:

Ctrl+Click

During single click, any existing item in the selection list be cleared, and only the item clicked recently is there in the selection list. To avoid cleaning the old selected item, Ctrl key must be on hold when clicking.

Rubber band selection

Clicking and dragging in the diagram area allows you to create a rectangular region. The elements covered within this rectangular region will be selected when you release the mouse button.

In rubber band selection, you can set the selection of items by region using the following modes:

  • CompleteIntersect: Selects items that are fully covered within the rectangular selection region.
  • PartialIntersect: Selects items that are partially covered within the rectangular selection region.

This can be configured with the rubberBandSelectionMode.

Select/Unselect elements using program

The select and clearSelection methods are used to dynamically select or clear the selection of elements at runtime. The following code example demonstrates how these methods can be utilized to select or clear the selection of elements.

let nodes = [
  {
    id: 'node1',
    width: 90,
    height: 60,
    offsetX: 100,
    offsetY: 100,
    style: {
        fill:   '#6BA5D7',
        strokeColor: 'white',
        strokeWidth: 1
    },
    }
]
export default {
    name: 'app'
    data() {
        return {
            width: '100%', height: '600px', nodes: nodes
        }
    },
    mounted: function () {
        const diagramInstance = this.$refs.diagram.ej2instances;
          //Select a specified collection of nodes and connectors in the diagram
          diagramInstance.select([diagramInstance.nodes[0]]);
          //Removes all elements from the selection list, clearing the current selection.
          diagramInstance.clearSelection();
    }
}

Get selected items

You can get the current selected items from the nodes and connectors collection of the selectedItems property of the diagram model.

let nodes = [
  {
    id: 'node1',
    width: 90,
    height: 60,
    offsetX: 100,
    offsetY: 100,
    style: {
        fill:   '#6BA5D7',
        strokeColor: 'white',
        strokeWidth: 1
    },
    }
]
export default {
    name: 'app'
    data() {
        return {
            width: '100%', height: '600px', nodes: nodes
        }
    },
    mounted: function () {
        const diagramInstance = this.$refs.diagram.ej2instances;
        let selectedNodes = diagramInstance.selectedItems.nodes;
        let selectedConnectors = diagramInstance.selectedItems.connectors;
    }
}

Toggle selection

The canToggleSelection property determines whether the selection state of a diagram element should toggle with a mouse click at runtime. By default, this property is set to false. In the following example, the node can be selected with the first click and unselected with the second click.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :selectedItems="selectedItems"></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    height: 100,
    width: 100,
    style: {
        fill: '#6BA5D7',
        strokeColor: 'white'
    },
  },
];

const width = "100%";
const height = "350px";
const selectedItems = { canToggleSelection: true }
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :selectedItems="selectedItems"
    ></ejs-diagram>
  </div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    height: 100,
    width: 100,
    style: {
        fill: '#6BA5D7',
        strokeColor: 'white'
    },
  },
];

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      width: '100%',
      height: '700px',
      nodes: nodes,
      selectedItems: { canToggleSelection: true },
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Select entire elements in diagram programmatically

The client-side method selectAll used to select all the elements such as nodes/connectors in the diagram. Refer to the following link which shows how to use selectAll method on the diagram.

Drag

  • An object can be dragged by clicking and dragging it. When multiple elements are selected, dragging any one of the selected elements move every selected element.
  • When you drag the elements in the diagram, the positionChange event gets triggered and to do customization in this event.

Resize

  • Selector is surrounded by eight thumbs. When dragging these thumbs, selected items can be resized.
  • When one corner of the selector is dragged, opposite corner is in a static position.
  • When a node is resized, the sizeChange event gets triggered.

NOTE

While dragging and resizing, the objects are snapped towards the nearest objects to make better alignments.

Aspect ratio

Maintaining aspect ratio in diagram means that when you resize a node, by dragging its corner, both its width and height adjust proportionally. This ensures that the node retains its original shape and proportions. Aspect ratio constraints can be applied by configuring the NodeConstraints property.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' ></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram, NodeConstraints } from '@syncfusion/ej2-vue-diagrams';

const nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    height: 100,
    width: 100,
    style: {
        fill: '#6BA5D7',
        strokeColor: 'white'
    },
    constraints: NodeConstraints.Default | NodeConstraints.AspectRatio,
  },
];

const width = "100%";
const height = "350px";
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
    ></ejs-diagram>
  </div>
</template>
<script>
import { DiagramComponent, NodeConstraints } from '@syncfusion/ej2-vue-diagrams';
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    height: 100,
    width: 100,
    style: {
        fill: '#6BA5D7',
        strokeColor: 'white'
    },
    constraints: NodeConstraints.Default | NodeConstraints.AspectRatio,
  },
];

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      width: '100%',
      height: '700px',
      nodes: nodes,
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Customize the resize-thumb

You can change the size of the node resize thumb and the connector end point handle by using the handleSize property. The appearance such as fill, stroke, and stroke width of the node resize thumb and connector end point handle can be customized by overriding the e-diagram-resize-handle and e-diagram-endpoint-handle classes respectively.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :selectedItems="selectedItems" :connectors="connectors"></ejs-diagram>
    </div>
</template>
<script setup>
import { onMounted, ref } from "vue";
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 250,
    height: 100,
    width: 100,
    style: { fill: '#6BA5D7', strokeColor: 'white' },
  },
];
const connectors = [
  {
    id: 'con1',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 300, y: 150 },
  },
];

const width = "100%";
const height = "350px";
const selectedItems = { handleSize: 40 }
onMounted(function () {
    const diagramInstance = this.$refs.diagram.ej2Instances;
    diagramInstance.select([diagramInstance.nodes[0]]);
});
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :connectors="connectors"
      :selectedItems="selectedItems"
    ></ejs-diagram>
  </div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 250,
    height: 100,
    width: 100,
    style: { fill: '#6BA5D7', strokeColor: 'white' },
  },
];
let connectors = [
  {
    id: 'con1',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 300, y: 150 },
  },
];

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      width: '100%',
      height: '700px',
      nodes: nodes,
      connectors: connectors,
      selectedItems: { handleSize: 40 },
    };
  },
  mounted: function () {
    const diagramInstance = this.$refs.diagram.ej2Instances;
    diagramInstance.select([diagramInstance.nodes[0]]);
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

The appearance such as fill, stroke, and stroke width of the node resize thumb and connector end point handle can be customized by overriding the e-diagram-resize-handle and e-diagram-endpoint-handle classes respectively.

Rotate

  • A rotate handler is placed above the selector. Clicking and dragging the handler in a circular direction lead to rotate the node.
  • The node is rotated with reference to the static pivot point.
  • Pivot thumb (thumb at the middle of the node) appears while rotating the node to represent the static point.

Customize rotate handle position

The position of the rotate handle can be adjusted by modifying the pivot point of the node using the pivot property. By default, the pivot point is set to (0.5, 0.5). The following example shows how to render the rotate handle at the left top corner of the node.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :selectedItems="selectedItems"></ejs-diagram>
    </div>
</template>
<script setup>
import { onMounted, ref } from "vue";
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

const nodes = [{
  // Position of the node
  offsetX: 250,
  offsetY: 250,
  // Size of the node
  width: 100,
  height: 100,
  pivot: {
      x: 0,
      y: 0
  },
  style: {
      fill: '#6BA5D7',
      strokeColor: 'white'
  },
  // Text(label) added to the node
}];

const width = "100%";
const height = "350px";
onMounted(function () {
    const diagramInstance = this.$refs.diagram.ej2Instances;
    diagramInstance.select([diagramInstance.nodes[0]]);
});
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
    ></ejs-diagram>
  </div>
</template>
<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';
let nodes = [{
  // Position of the node
  offsetX: 250,
  offsetY: 250,
  // Size of the node
  width: 100,
  height: 100,
  pivot: {
      x: 0,
      y: 0
  },
  style: {
      fill: '#6BA5D7',
      strokeColor: 'white'
  },
  // Text(label) added to the node
}];

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      width: '100%',
      height: '700px',
      nodes: nodes,
    };
  },
  mounted: function () {
    const diagramInstance = this.$refs.diagram.ej2Instances;
    diagramInstance.select([diagramInstance.nodes[0]]);
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Connection editing

Each segment of a selected connector is editable with some specific handles/thumbs.

NOTE

For connector editing, you have to inject the ConnectorEditing module.

Drag connector end points

Source and target points of the selected connectors are represented with two handles. Clicking and dragging those handles help you to adjust the source and target points.

  • If you drag the connector end points, then the following events can be used to do your customization.
  • When the connector source point is changed, the sourcePointChange event gets triggered.
  • When the connector target point is changed, the targetPointChange event gets triggered.
  • When you connect connector with ports/node or disconnect from it, the connectionChange event gets triggered.

Straight segment editing

The end point of each straight segment is represented by a thumb that allows you to edit the segment. You can insert any number of new segments into a straight line by clicking while holding the Shift and Ctrl keys (Ctrl+Shift+Click).

  • Straight segments can be removed by clicking the segment end point, when Ctrl and Shift keys are pressed (Ctrl+Shift+Click).

Orthogonal segment editing

  • Orthogonal thumbs allow you to adjust the length of adjacent segments by clicking and dragging it.
  • When necessary, some segments are added or removed automatically, when dragging the segment. This is to maintain proper routing of orthogonality between segments.

Bezier segment editing

Bezier segment thumbs allow you to adjust the segments by clicking and dragging them.

Bezier Control Points

Bezier segments are annotated with two thumbs representing the control points. These control points can be adjusted by clicking and dragging the control thumbs. Dragging the control point changes the angle and distance of the points from the segment point, modifying the curve.

bezier-segement-thumb-gif

Restrict Interaction in Negative Axis Area

The Diagram component includes a built-in option to restrict user interactions within the negative axis region—areas defined by negative X or Y coordinates. By enabling the RestrictNegativeAxisDragDrop constraint, the following interactions are prevented:

  • Dragging: Diagram elements cannot be dragged into areas with negative coordinates.
  • Resizing: The size of diagram objects cannot be adjusted to extend into the negative axis.
  • Dropping Symbols: Symbols from the palette cannot be dropped in the negative region.
export default {
    name: 'app'
    data() {
      return {
          width: "100%", height: "350px",
          // Prevent diagram interactions in the negative region
          constraints: DiagramConstraints.Default |
                       DiagramConstraints.RestrictNegativeAxisDragDrop        
      }
    }
}

negativeAxisRestrict

NOTE

A symbol dragged from the palette will only be added to the diagram if it’s fully positioned within the positive coordinate space.

User handles

  • User handles are used to add some frequently used commands around the selector. To create user handles, define and add them to the userHandles collection of the selectedItems property. The name property of user handle is used to define the name of the user handle and its further used to find the user handle at runtime and do any customization.

The following events are triggered when interacting with a user handle:

For more information, refer to the user handle events.

Fixed user handle

Fixed user handles are used to perform specific actions when interacted with. Unlike regular user handles, fixedUserHandles are defined within the node/connector object, allowing different fixed user handles to be added to different nodes.

The following events are triggered when interacting with a fixed user handle:

For more information, refer to the fixed user handle events.

Determining Mouse Button Clicks

The diagram component can determine which mouse button was clicked. For example, when the right mouse button is clicked, the click event will specify that the right button was clicked. This is handled through the mouse click event, which provides details about whether the left or right button was clicked.

Notification Description
Left When the left mouse button is clicked, left is notified
Middle When the mouse wheel is clicked, middle is notified
Right When the right mouse button is clicked, right is notified
<template>
  <div id="app">
    <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :click="click"></ejs-diagram>
  </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

let nodes = [{
  // Position of the node
  offsetX: 250,
  offsetY: 250,
  // Size of the node
  width: 100,
  height: 100,
  style: {
    fill: '#6BA5D7',
    strokeColor: 'white'
  },
  // Text(label) added to the node
}]

const width = "100%";
const height = "700px";
const click = (args) => {
  //Obtains the button clicked
  let clickNotify = args.button
}
</script>
<template>
  <div id="app">
    <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :click="click"></ejs-diagram>
  </div>
</template>
<script>

import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';

let nodes = [{
  // Position of the node
  offsetX: 250,
  offsetY: 250,
  // Size of the node
  width: 100,
  height: 100,
  style: {
    fill: '#6BA5D7',
    strokeColor: 'white'
  },
  // Text(label) added to the node
}]

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent
  },
  data() {
    return {
      width: "100%",
      height: "700px",
      nodes: nodes,
      click: (args) => {
        //Obtains the button clicked
        let clickNotify = args.button
      }
    }
  },
}
</script>

Allow drop

The diagram supports dropping a node or connector onto another node or connector. To determine the target where the node or connector is dropped, you need to enable the allowDrop constraint in the node’s or connector’s constraints property. This setting enables a highlighter to indicate potential drop targets when dragging any node or connector over another one. Upon dropping the node or connector, the drop event is triggered to indicate which element was dropped over which other element.

Zoom pan

When a large diagram is loaded, only certain portion of the diagram is visible. The remaining portions are clipped. Clipped portions can be explored by scrolling the scrollbars or panning the diagram. You can zoom in or out on the diagram by using Ctrl + mouse wheel. When the diagram is zoomed or panned, the scrollChange event gets triggered.

Pan Status Description
Start When the mouse is clicked and dragged the status is notified as start.
Progress When the mouse is in motion the status is notified as progress.
Completed When panning is stopped the status is notified with completed.

Zoom Pan

Keyboard

Diagram provides support to interact with the elements with key gestures. By default, some in-built commands are bound with a relevant set of key combinations.

The following table illustrates those commands with the associated key values.

Shortcut Key Command Description
Ctrl + A selectAll Select all nodes/connectors in the diagram.
Ctrl + C copy Copy the diagram selected elements.
Ctrl + V paste Pastes the copied elements.
Ctrl + X cut Cuts the selected elements.
Ctrl + Z undo Reverses the last editing action performed on the diagram.
Ctrl + Y redo Restores the last editing action when no other actions have occurred since the last undo on the diagram.
Delete delete Deletes the selected elements.
Ctrl/Shift + Click on object   Multiple selection (Selector binds all selected nodes/connectors).
Up Arrow nudge(“up”) nudgeUp: Moves the selected elements towards up by one pixel.
Down Arrow nudge(“down”) nudgeDown: Moves the selected elements towards down by one pixel.
Left Arrow nudge(“left”) nudgeLeft: Moves the selected elements towards left by one pixel.
Right Arrow nudge(“right”) nudgeRight: Moves the selected elements towards right by one pixel.
Ctrl + MouseWheel zoom Zoom (Zoom in/Zoom out the diagram).
F2 startLabelEditing Starts to edit the label of selected element.
Esc endLabelEditing Sets the label mode as view and stops editing.
Tab Tab to Focus Select the diagram element based on the rendering order when using the “Tab” key.
Shift + Tab Go to Previous Object This command is employed to shift the selection to the preceding object based on the z-order.
Control + B Bold Toggle bold formatting for the selected text.
Control + I Italic Toggle italic formatting for the selected text.
Control + U Underline Toggle underline formatting for the selected text.
Control + D Duplicate Duplicate a selected shape.
Control + G Group Group together multiple selected shapes, allowing them to be treated as a single shape.
Control + Shift + U UnGroup Ungroup shapes within a previously grouped selection.
Control + R Rotate clockwise Rotate the selected nodes in clockwise.
Control + L Rotate anti-clockwise Rotate the selected nodes in counterclockwise.
Control + H Flip Horizontal Flip the selected elements horizontally.
Control + J Flip Vertical Flip the selected elements vertically.
Control + 1 Pointer tool Activate the pointer tool.
Control + 2 Text tool Activate the text tool.
Control + 3 Connector tool Activate the connector tool.
Control + 5 Freeform tool Activate the freeform tool.
Control + 6 Line tool Activate the polyline tool.
Control + + Zoom In Zoom in the diagram.
Control + - Zoom Out Zoom out the diagram.
Shift + Up Arrow Up Moves the selected elements towards up by 5 pixel.
Shift + Down Arrow Down Moves the selected elements towards down by 5 pixel.
Shift + Left Arrow Left Moves the selected elements towards left by 5 pixel.
Shift + Right Arrow Right Moves the selected elements towards right by 5 pixel.
Control + Shift + L Align Text Left Align the selected text to the left.
Control + Shift + C Center Text Horizontally Center the selected text horizontally.
Control + Shift + R Align Text Right Align the selected text to the right.
Control + Shift + J Justify Text Horizontally Justify the selected text, aligning it to both the left and right margins.
Control + Shift + E Top-align Text Vertically Align the selected text to the top vertically.
Control + Shift + M Center Text Vertically Center the selected text vertically.
Control + Shift + V Bottom-align Text Vertically Align the selected text to the bottom vertically.
Control + Shift + B Send To Back Send the selected shape backward in the stacking order, making it appear behind other shapes.
Control + Shift + F Bring To Front Bring the selected shape forward in the stacking order, making it appear in front of other shapes.
Control + [ Send Backward Move the selected shape one step backward in the layer order.
Control + ] Bring Forward Move the selected shape one step forward in the layer order.

See Also